var T_FILE = "zxnz_core_fs_File";
var T_FOLDER = "zxnz_core_fs_Folder";
var node_fs = require('fs');
var mimes = require('./mimes');
//var node_canvas = require('canvas');
module.exports = zn.Controller('fetch', {
    Service: require('./File.Service'),
    methods: {
        readAsPDF: {
            method: 'GET/POST',
            route: '/readAsPDF/:tempName',
            value: function (request, response, application, context, router){
                var _tempName = request.getValue('tempName');
                var _file = request.getSavedFilByKey(_tempName);
                if(!_file){
                    return response.error('文件不存在！'), false;
                }
                _file.ext = _file.ext.toLocaleLowerCase();

                if(!node_fs.existsSync(_file.path)){
                    return response.error('文件已经被删除, 请联系管理员'), false;
                }
                
                var _serverResponse = response._serverResponse;
                var _fileStat = node_fs.statSync(_file.path);
                _file.encoding = 'binary';
                if(!_fileStat.isFile()){
                    return response.error('该请求文件路径出错, 请联系管理员'), false;
                }
                if(_file.ext != '.pdf') {
                    return this.service.officeToPDF(_file.path, function (filePath, done){
                        /*
                        var _content = node_fs.readFileSync(filePath, {
                            encoding: _file.encoding,
                            flag: 'r'
                        });*/

                        context.initHttpHeaderCommonSetting(request._clientRequest, _serverResponse);
                        _serverResponse.setHeader('Content-Type', mimes['.pdf'] + ";charset=" + _file.encoding);
                        _serverResponse.setHeader('Content-Length', Buffer.byteLength(done, _file.encoding));
                        _serverResponse.writeHead(200, "OK");
                        _serverResponse.end(done, _file.encoding);
                    }, function (err){
                        response.error(err);
                    });
                }
                
                var _content = node_fs.readFileSync(_file.path, {
                    encoding: _file.encoding,
                    flag: 'r'
                });

                context.initHttpHeaderCommonSetting(request._clientRequest, _serverResponse);
                _serverResponse.setHeader('Content-Type', mimes[_file.ext] + ";charset=" + _file.encoding);
                _serverResponse.setHeader('Content-Length', Buffer.byteLength(_content, _file.encoding));
                _serverResponse.writeHead(200, "OK");
                _serverResponse.end(_content, _file.encoding);
            }
        },
        videoPlay: {
            method: 'GET/POST',
            route: '/video.play/:tempName',
            value: function (request, response, application, context, router){
                var _tempName = request.getValue('tempName');
                var _file = request.getSavedFilByKey(_tempName);
                if(!_file){
                    return response.error('文件不存在！'), false;
                }
                _file.ext = _file.ext.toLocaleLowerCase();
                if(!node_fs.existsSync(_file.path)){
                    return response.error('文件已经被删除, 请联系管理员'), false;
                }
                var _fileStat = node_fs.statSync(_file.path);
                if(!_fileStat.isFile()){
                    return response.error('该请求文件路径出错, 请联系管理员'), false;
                }
                if(mimes[_file.ext].indexOf('video') != 0){
                    return response.error('该请求不是视频类型，请求出错'), false;
                }
                _file.encoding = 'binary';
                var _serverResponse = response._serverResponse;
                var _clientRequest = request._clientRequest;
                var _range = _clientRequest.headers.range || 'bytes=0-';
                var positions = _range.replace(/bytes=/, "").split("-");
                var start = parseInt(positions[0], 10);
                var total = _fileStat.size;
                var end = positions[1] ? parseInt(positions[1], 10) : total - 1;
                var chunksize = (end - start) + 1;

                context.initHttpHeaderCommonSetting(request._clientRequest, _serverResponse);
                _serverResponse.setHeader('Content-Type', mimes[_file.ext] + ";charset=" + _file.encoding);
                _serverResponse.setHeader('Content-Length', chunksize);
                _serverResponse.setHeader('Content-Range', "bytes " + start + "-" + end + "/" + total);
                _serverResponse.setHeader('Accept-Ranges', "bytes");
                _serverResponse.writeHead(206, "OK");
                var stream = node_fs.createReadStream(_file.path, { 
                    start: start, 
                    end: end 
                }).on("open", function() {
                    stream.pipe(_serverResponse);
                }).on("error", function(err) {
                    _serverResponse.end(err);
                });
            }
        },
        video: {
            method: 'GET/POST',
            route: '/video/:tempName',
            value: function (request, response, application, context, router){
                var _tempName = request.getValue('tempName');
                var _file = request.getSavedFilByKey(_tempName);
                if(!_file){
                    return response.error('文件不存在！'), false;
                }
                _file.ext = _file.ext.toLocaleLowerCase();

                if(!node_fs.existsSync(_file.path)){
                    return response.error('文件已经被删除, 请联系管理员'), false;
                }
                var _fileStat = node_fs.statSync(_file.path);
                if(!_fileStat.isFile()){
                    return response.error('该请求文件路径出错, 请联系管理员'), false;
                }
                if(mimes[_file.ext].indexOf('video') != 0){
                    return response.error('该请求不是视频类型，请求出错'), false;
                }
                _file.encoding = 'binary';
                var _serverResponse = response._serverResponse;
                var _content = node_fs.readFileSync(_file.path, {
                    encoding: _file.encoding,
                    flag: 'r'
                });

                context.initHttpHeaderCommonSetting(request._clientRequest, _serverResponse);
                _serverResponse.setHeader('Content-Type', mimes[_file.ext] + ";charset=" + _file.encoding);
                _serverResponse.setHeader('Content-Length', Buffer.byteLength(_content, _file.encoding));
                _serverResponse.writeHead(200, "OK");
                _serverResponse.end(_content, _file.encoding);
            }
        },
        image: {
            method: 'GET/POST',
            route: '/image/:tempName',
            value: function (request, response, application, context, router){
                var _tempName = request.getValue('tempName');
                var _file = request.getSavedFilByKey(_tempName);
                if(!_file){
                    return response.error('文件不存在！'), false;
                }
                _file.ext = _file.ext.toLocaleLowerCase();

                if(!node_fs.existsSync(_file.path)){
                    return response.error('文件已经被删除, 请联系管理员'), false;
                }
                var _fileStat = node_fs.statSync(_file.path);
                if(!_fileStat.isFile()){
                    return response.error('该请求文件路径出错, 请联系管理员'), false;
                }
                if(!mimes[_file.ext] || mimes[_file.ext].indexOf('image') != 0){
                    return response.error('该请求不是图片类型，请求出错'), false;
                }
                _file.encoding = 'binary';
                var _serverResponse = response._serverResponse;
                var _content = node_fs.readFileSync(_file.path, {
                    encoding: _file.encoding,
                    flag: 'r'
                });

                context.initHttpHeaderCommonSetting(request._clientRequest, _serverResponse);
                _serverResponse.setHeader('Content-Type', mimes[_file.ext] + ";charset=" + _file.encoding);
                _serverResponse.setHeader('Content-Length', Buffer.byteLength(_content, _file.encoding));
                _serverResponse.writeHead(200, "OK");
                _serverResponse.end(_content, _file.encoding);
            }
        },
        file: {
            method: 'GET/POST',
            route: '/file/:tempName',
            value: function (request, response, application, context, router){
                var _tempName = request.getValue('tempName');
                zxnz.store
                    .beginPoolTransaction()
                    .query(zxnz.sql.select({
                        table: T_FILE,
                        where: {
                            zxnz_core_fs_file_Temp_Name: _tempName
                        }
                    }))
                    .commit()
                    .then(function (data){
                        if(!data.length){
                            return response.error('文件不存在！'), false;
                        }else{
                            var _file = data[0];
                            if(!node_fs.existsSync(_file.zxnz_core_fs_file_Saved_Path)){
                                return response.error('文件已经被删除, 请联系管理员'), false;
                            }
                            var _fileStat = node_fs.statSync(_file.zxnz_core_fs_file_Saved_Path);
                            if(!_fileStat.isFile()){
                                return response.error('该请求文件路径出错, 请联系管理员'), false;
                            }
                            response.success({
                                encoding: _file.zxnz_core_fs_file_Encoding,
                                ext: _file.zxnz_core_fs_file_Ext,
                                lastModifiedDate: _file.zxnz_Inserted_Time,
                                name: _file.zxnz_core_fs_file_Name,
                                path: _file.zxnz_core_fs_file_Path,
                                savedName: _file.zxnz_core_fs_file_Saved_Name,
                                size: _file.zxnz_core_fs_file_Size,
                                tempName: _file.zxnz_core_fs_file_Temp_Name,
                                type: _file.zxnz_core_fs_file_Type
                            });
                        }
                    }, function (err){
                        response.error(err);
                    });
            }
        },
        files: {
            method: 'GET/POST',
            route: '/files/:tempNames',
            value: function (request, response, application, context, router){
                var _tempNames = request.getValue('tempNames');
                zxnz.store
                    .beginPoolTransaction()
                    .query(zxnz.sql.select({
                        table: T_FILE,
                        where: "locate(concat(',', zxnz_core_fs_file_Temp_Name, ','), ',{0},')<>0".format(_tempNames)
                    }))
                    .commit()
                    .then(function (data){
                        var _files = data,
                            _data = [];
                        for(var _file of _files){
                            if(node_fs.existsSync(_file.zxnz_core_fs_file_Saved_Path)){
                                var _fileStat = node_fs.statSync(_file.zxnz_core_fs_file_Saved_Path);
                                if(_fileStat.isFile()){
                                    _data.push({
                                        encoding: _file.zxnz_core_fs_file_Encoding,
                                        ext: _file.zxnz_core_fs_file_Ext,
                                        lastModifiedDate: _file.zxnz_Inserted_Time,
                                        name: _file.zxnz_core_fs_file_Name,
                                        path: _file.zxnz_core_fs_file_Path,
                                        savedName: _file.zxnz_core_fs_file_Saved_Name,
                                        size: _file.zxnz_core_fs_file_Size,
                                        tempName: _file.zxnz_core_fs_file_Temp_Name,
                                        type: _file.zxnz_core_fs_file_Type
                                    });
                                }
                            }
                        }

                        response.success(_data);
                    }, function (err){
                        response.error(err);
                    });
            }
        }
    }
});