var node_path = require('path');
var node_fs = require('fs');
var libre = require('libreoffice-convert');
module.exports = zn.ControllerService({
    methods: {
        officeToPDF: function (filePath, success, error){
            var _TYPE = '.pdf';
            if(!filePath){
                return error && error(), false;
            }

            var _paths = filePath.split('.'), _ext = _paths.pop();
            var _newPath = _paths + _TYPE;
            var _content = node_fs.readFileSync(filePath);
            if(node_fs.existsSync(_newPath)){
                return success && success(_newPath, node_fs.readFileSync(_newPath)), false;
            }
            // Convert it to pdf format with undefined filter (see Libreoffice doc about filter)
            libre.convert(_content, _TYPE, undefined, (err, done) => {
                if (err) {
                    zn.error(`Error converting file: ${err}`);
                    error && error(err);
                }else{
                    // Here in done you have pdf file which you can save or transfer in another stream
                    node_fs.writeFileSync(_newPath, done);
                    success && success(_newPath, done);
                }
            });
        }
    }
});