var node_fs = require('fs');
var node_path = require('path');
module.exports = zn.Controller('folder', {
    methods: {
        filelist: {
            method: 'GET/POST',
            argv: {
                folder: null
            },
            value: function (request, response, application, context, router){
                var _config = context.getFileUploadConfig();
                var _folder = request.getValue('folder');
                var _path = node_path.join(_config.savedDir, _folder);
                zn.error('Path: ', _path);
                if(!node_fs.existsSync(_path)){
                    return response.error('文件目录不存在');
                }
                var _dir = node_fs.readdirSync(_path, {
                    withFileTypes: true
                });

                _dir = _dir.map(function (item){
                    item.isDirectory = item.isDirectory();
                    item.isFile = item.isFile();
                    item.stat = node_fs.statSync(_path + '/' + item.name);
                    if(item.isFile){
                        item.ext = node_path.extname(_path + '/' + item.name);
                    }

                    return item;
                });
                response.success(_dir);
            }
        }
    }
});